drop table category;
\echo
\echo
\echo
\echo 'SAMPLE TREE DATA STRUCTURE FOR THE TUTORIAL:'
\echo
\echo '             category 1'
\echo '           /          \\'
\echo '          /            \\'
\echo '   category 1.2     category 1.2'
\echo '        |'
\echo '        |'
\echo '   category 1.2.1'
\echo 
\echo
\echo 'this is the final structure that we want to have. '
\echo
\echo
\echo
\echo
\echo 'CREATE SAMPLE DATA TABLE'
\echo 'In this table we have only the plain data'
\echo 'without hirerachical information'
\echo
\echo '#CREATE TABLE category (id integer primary key, cat_name varchar);'
CREATE TABLE category (id integer primary key, cat_name varchar);
\echo
\echo ' #insert into category values (1, \'category 1\');'
insert into category values (1, 'category 1');
\echo ' #insert into category values (2, \'category 1.1\');'
insert into category values (2, 'category 1.1');
\echo ' #insert into category values (3, \'category 1.2\');'
insert into category values (3, 'category 1.2');
\echo ' #insert into category values (4, \'category 1.2.1\');'
insert into category values (4, 'category 1.2.1');
\echo
\echo
\echo
\echo
\echo 
\echo 'CREATE THE TREE STRUCTURE'
\echo '-------------------------'
\echo
\echo
\echo
\echo 'FIRST WAY:'
\echo '---------'
\echo 
\echo 'first create nodes then set the hierarchy'
\echo
\echo 'the output of previus commands affects the input of future commands.'
\echo
\echo 'for the data structures that the functions returns look at functions.txt'
\echo
\echo
\echo 'create tree'
\echo 'SELECT tree.create_tree(\'t1\', \'categories hierarchy 1\');'
SELECT tree.create_tree('t1', 'categories hierarchy 1');
\echo 'add nodes without structure'
\echo ''
\echo '#SELECT tree.add_orphan_node(\'t1\',1);'
SELECT tree.add_orphan_node('t1',1);
\echo '#SELECT tree.add_orphan_node(\'t1\',2);'
SELECT tree.add_orphan_node('t1',2);
\echo '#SELECT tree.add_orphan_node(\'t1\',3);'
SELECT tree.add_orphan_node('t1',3);
\echo '#SELECT tree.add_orphan_node(\'t1\',4);'
SELECT tree.add_orphan_node('t1',4);
\echo
\echo 'add hierarchy information'
\echo '#SELECT tree.set_root_node(1);'
SELECT tree.set_root_node(1);
\echo '#SELECT tree.set_parentship(1,2);'
SELECT tree.set_parentship(1,2);
\echo '#SELECT tree.set_parentship(1,3);'
SELECT tree.set_parentship(1,3);
\echo '#SELECT tree.set_parentship(2,4);'
SELECT tree.set_parentship(2,4);
\echo
\echo ' RESULT:'
\echo '           (1->1)'
\echo '           /     \\'
\echo '        (2->2)  (3->3)'
\echo '          |'
\echo '        (4->4)'
\echo ' '
\echo ' (a,b) : (node_id, category.id)'
\echo '        '
\echo        
\echo
\echo
\echo
\echo
\echo
\echo
\echo
\echo
\echo
\echo 'SECOND WAY:'
\echo '-----------'
\echo 'create nodes with hierarchy information at once'
\echo
\echo 'the output of previus commands affects the input of future commands.'
\echo
\echo 'for the data structures that the functions returns look at functions.txt' 
\echo
\echo '#SELECT tree.create_tree(\'t2\', \'categories hierarchy 2\');'
SELECT tree.create_tree('t2', 'categories hierarchy 2');
\echo
\echo '#SELECT tree.add_root_node('t2',1);'
SELECT tree.add_root_node('t2',1);
\echo '#SELECT tree.add_node(5,2);'
SELECT tree.add_node(5,2);
\echo '#SELECT tree.add_node(5,3);'
SELECT tree.add_node(5,3);
\echo '#SELECT tree.add_node(6,4);'
SELECT tree.add_node(6,4);
\echo
\echo 'RESULT:'
\echo '           (5->1)'
\echo '           /     \\'
\echo '        (6->2)  (7->3)'
\echo '          |'
\echo '        (8->4)'
\echo 
\echo '(a,b) : (node_id, category.id)'
\echo        
\echo
\echo  
\echo
\echo
\echo
\echo
\echo
\echo
\echo 'THIRD WAY: '
\echo '-----------'
\echo 'first create nodes with names (the nodes id are created also at back-end)'
\echo 'then set the hierarchy information'
\echo '(this way has overhead of the name retrival)'
\echo
\echo 'the output of previus commands DOES NOT affect the input of future commands.'
\echo
\echo 'for the data structures that the functions returns look at functions.txt' 
\echo ''
\echo '#SELECT tree.create_tree(\'t3\', \'categories hierarchy 2\');'
SELECT tree.create_tree('t3', 'categories hierarchy 2');
\echo
\echo '#SELECT tree.add_named_orphan_node(\'t3\',\'n1\',1);'
SELECT tree.add_named_orphan_node('t3','n1',1);
\echo '#SELECT tree.add_named_orphan_node(\'t3\',\'n2\',2);'
SELECT tree.add_named_orphan_node('t3','n2',2);
\echo '#SELECT tree.add_named_orphan_node(\'t3\',\'n3\',3);'
SELECT tree.add_named_orphan_node('t3','n3',3);
\echo '#SELECT tree.add_named_orphan_node(\'t3\',\'n4\',4);'
SELECT tree.add_named_orphan_node('t3','n4',4);
\echo
\echo '#SELECT tree.set_root_node(\'n1\');'
SELECT tree.set_root_node('n1');
\echo '#SELECT tree.set_parentship(\'n1\',\'n2\');'
SELECT tree.set_parentship('n1','n2');
\echo '#SELECT tree.set_parentship(\'n1\',\'n3\');'
SELECT tree.set_parentship('n1','n3');
\echo '#SELECT tree.set_parentship(\'n2\',\'n4\');'
SELECT tree.set_parentship('n2','n4');
\echo
\echo ' RESULT:'
\echo '           (n1->1)'
\echo '           /     \\'
\echo '        (n2->2)  (n3->3)'
\echo '          |'
\echo '        (n4->4)'
\echo ''
\echo ' (a,b) : (node_name, category.id)'
\echo
\echo
\echo
\echo
\echo
\echo the three tree creation methods can be mixed up
\echo
\echo
\echo
\echo
\echo
\echo 
\echo 'NODE RETRIVAL'
\echo '-------------'
\echo for the data structures that the functions returns look at functions.txt 
\echo
\echo 'get tree nodes'
\echo
\echo 'SELECT * FROM tree.get_nodes(\'t1\');'
\echo 'SELECT * FROM tree.get_leaf_nodes(\'t1\');'
\echo 'SELECT * FROM tree.get_internal_nodes(\'t1\');'
\echo 'SELECT * FROM tree.get_internal_nodes(\'t1\');'
\echo
\echo 'get childs of a node'
\echo 'SELECT * from tree.get_childs(1);'
\echo
\echo 'get parend node'
\echo 'SELECT tree.get_parent(2);'
\echo 'get path from node to root'
\echo 'SELECT * FROM tree.get_path(4,true);'
\echo
\echo 'combine the real data with the tree  structure.'
\echo 'SELECT * FROM public.category where id in   (SELECT node_data_id FROM tree.get_leaf_nodes(\'t1\'));'
\echo 'SELECT * FROM public.category WHERE id = (tree.get_parent(2)).id;'


\echo
\echo 'TREE TRAVERSAL'
\echo '--------------'
\echo
\echo for the data structures that the functions returns look at functions.txt 

\echo simple traversal
\echo 'SELECT * from tree.traverse_tree(\'t1\')';
\echo
\echo traversal with level
\echo 'SELECT * from tree.traverse_tree_level(\'t1\');'
\echo
\echo traversal with groups
\echo 'SELECT * from tree.traverse_group(1,true);';
\echo
\echo '#SELECT' 
\echo ' CASE'
\echo '  WHEN group_tag = 1 THEN \'<ul>\''
\echo '  WHEN group_tag = 2 THEN \'</ul>\''
\echo '  WHEN group_tag is null THEN  \'<li>\'  || node_data_id  || \'</li>\''
\echo ' END AS tags'
\echo ' from tree.traverse_group(1,8,true) t ;'

SELECT 
 CASE
  WHEN group_tag = 1 THEN '<ul>'
  WHEN group_tag = 2 THEN '</ul>'
  WHEN group_tag is null THEN  '<li>'  || node_data_id  || '</li>'
 END AS tags
 from tree.traverse_group(1,8,true) t ;

\echo
\echo
\echo '#SELECT' 
\echo ' CASE'
\echo '  WHEN group_tag = 1 THEN \'<ul>\''
\echo '  WHEN group_tag = 2 THEN \'</ul>\''
\echo '  WHEN group_tag is null THEN  \'<li>\'  || d.cat_name  || \'</li>\''
\echo ' END AS tags'
\echo ' from tree.traverse_group(1,8,true) t LEFT JOIN public.category d ON (t.node_data_id =  d.id) order by traversal_index ;'
\echo

SELECT
 CASE
 WHEN group_tag = 1 THEN '<ul>'
 WHEN group_tag = 2 THEN '</ul>'
 WHEN group_tag is null THEN  '<li>'  || d.cat_name  || '</li>'
 END AS tags
 from tree.traverse_group(1,8,true) t LEFT JOIN public.category d ON (t.node_data_id =  d.id) order by traversal_index ;

\echo    
\echo 'HTML RENDERING:'
\echo ''
\echo '       *  category 1'
\echo '             o category 2'
\echo '                + category 4'
\echo '             o category 3'
\echo ''
\echo 
\echo 
\echo 
\echo 
\echo 'SELECT '
\echo ' CASE'
\echo '  WHEN group_tag = 1 THEN \'<ul>\' '
\echo '  WHEN group_tag = 2 THEN \'</ul>\' '
\echo ' END AS grou_tags, d.cat_name  '
\echo ' from tree.traverse_group(1,8,true) t LEFT JOIN public.category d ON (t.node_data_id =  d.id) order by traversal_index ;'
\echo
SELECT 
 CASE
  WHEN group_tag = 1 THEN '<ul>'
  WHEN group_tag = 2 THEN '</ul>'
 END AS grou_tags, d.cat_name 
 from tree.traverse_group(1,8,true) t LEFT JOIN public.category d ON (t.node_data_id =  d.id) order by traversal_index ;

\echo 
\echo 
\echo 
\echo 
\echo 
\echo 
\echo
\echo 'METADATA '
\echo '--------'
\echo 'for the data structures that the functions returns look at functions.txt' 
\echo ''
\echo 'SELECT tree.set_node_name(3,\'my_interesting_node\');'
\echo 'SELECT tree.get_node(\'my_interesting_node\');'
\echo 'SELECT tree.get_node_id(\'my_interesting_node\');'
\echo
\echo
\echo
\echo 'VIEWS SAMPLE '
\echo '------------'
\echo
\echo
\echo 'CREATE VIEW public.category_view AS' 
\echo 'SELECT td.*, '
\echo ' n.id as treenode_id,'
\echo ' n.tree_id as treenode_tree_id,'
\echo ' n.weight as treenode_weight,'
\echo ' n.internal_weight as treenode_internal_weight,'
\echo ' n.level as treenode_level'
\echo 'from public.category td'
\echo 'JOIN tree.get_nodes(\'t1\') n ON (n.node_data_id = td.id);'
